#include <ogdf/basic/graph_generators.h>
#include <ogdf/layered/DfsAcyclicSubgraph.h>
#include <ogdf/fileformats/GraphIO.h>
#include <ogdf/basic/extended_graph_alg.h>

#include <ogdf/layered/MedianHeuristic.h>
#include <ogdf/layered/OptimalHierarchyLayout.h>
#include <ogdf/layered/OptimalRanking.h>
#include <ogdf/layered/SugiyamaLayout.h>

//#include <ogdf/fileformats/GraphIO.h>
//#include <ogdf/orthogonal/OrthoLayout.h>
//#include <ogdf/planarity/EmbedderMinDepthMaxFaceLayers.h>
//#include <ogdf/planarity/PlanarSubgraphFast.h>
//#include <ogdf/planarity/PlanarizationLayout.h>
//#include <ogdf/planarity/SubgraphPlanarizer.h>
//#include <ogdf/planarity/VariableEmbeddingInserter.h>
//
////#include <ogdf/basic/graph_generators.h>
//#include <ogdf/basic/simple_graph_alg.h>
////#include <ogdf/fileformats/GraphIO.h>
//#include <ogdf/upward/LayerBasedUPRLayout.h>
//#include <ogdf/upward/UpwardPlanarity.h>

void test_ogdf(matrix<int>& incidence,int num_boundary_vertices, int diagramnum)
{
	int num_vertices = incidence.numrows();

	cout << "test_ogdf" << endl;
	print (incidence,cout, 2,"add_interior_edges: ");
	
	Graph G;
//	GraphAttributes GA(G);
//	randomSimpleGraph(G, 10, 20);

//	string dot_data = "graph G {0--1--2--3--4--5--6--7--0 0--8--9--10--0 2--10 4--10 5--9 6--8}";
//	string dot_data = "graph G {0--1--2--3--4--5--6--7--0 0--8--9--6 0--10--4 2--10 2--8 1--9}";
//	string dot_data = "graph G {0--1--2--3--4--5--6--7--0 0--8 0--9 1--10 2--8 3--10 4--8 6--9 9--10 1--11 3--11 5--11 7--11}";


	ostringstream incidence_DOT;
	incidence_DOT << "graph G {0";
	for (int i=0; i< num_boundary_vertices; i++)
		incidence_DOT << "--" << (i+1)%num_boundary_vertices;
	
	for (int i=0; i<num_boundary_vertices; i++)
	{
		for (int j=num_boundary_vertices; j< num_vertices; j++)
		{
			if (incidence[i][j] == 1)
			{
				incidence_DOT << ' ' << i << "--" << j;
			}
		}
	}
	
	for (int i=num_boundary_vertices; i< num_vertices; i++)
	{
		for (int j=i+1; j< num_vertices; j++)
		{
			if (incidence[i][j] == 1)
			{
				incidence_DOT << ' ' << i << "--" << j;
			}
		}
	}		
	
	for (int i=0; i<num_boundary_vertices/2; i++)
		incidence_DOT << ' ' << 2*i+1 << "--" << num_vertices;
	
	incidence_DOT << '}';

	cout << "incidence_DOT = " << incidence_DOT.str() << endl;

	
//	ifstream input;
//	input.open("input-AB.dot");

//	istringstream input(dot_data);
	istringstream input(incidence_DOT.str());
	
//	if (GraphIO::readDOT(G,input))

/*
	// SUGIYAMA
    GraphAttributes GA(G,
      GraphAttributes::nodeGraphics |
      GraphAttributes::edgeGraphics |
      GraphAttributes::nodeLabel |
      GraphAttributes::edgeStyle |
      GraphAttributes::nodeStyle |
      GraphAttributes::nodeTemplate);
*/

	// ORTHOGANAL PLANARIZATION
    GraphAttributes GA(G,
    GraphAttributes::nodeGraphics | GraphAttributes::nodeType |
    GraphAttributes::edgeGraphics | GraphAttributes::edgeType);



/*
	// UPWARD PLANAR REPRESENTATION
GraphAttributes GA(G, GraphAttributes::nodeGraphics |
GraphAttributes::edgeGraphics | GraphAttributes::edgeArrow);
*/
	  
	if (GraphIO::readDOT(GA, G, input))
	{



/*

	// SUGIYAMA

    SugiyamaLayout SL;
    SL.setRanking(new OptimalRanking);
    SL.setCrossMin(new MedianHeuristic);
 
    OptimalHierarchyLayout *ohl = new OptimalHierarchyLayout;
    ohl->layerDistance(30.0);
    ohl->nodeDistance(25.0);
    ohl->weightBalancing(0.8);
    SL.setLayout(ohl);
 
    SL.call(GA);
    GraphIO::write(GA, "output-Sugiyama.gml", GraphIO::writeGML);
    GraphIO::write(GA, "output-Sugiyama.svg", GraphIO::drawSVG);
*/


   for (node v : G.nodes)
    {
        GA.width(v) /= 2;
        GA.height(v) /= 2;
    }
 
    PlanarizationLayout pl;
 
#ifdef TAKEOUT
    SubgraphPlanarizer *crossMin = new SubgraphPlanarizer;
    PlanarSubgraphFast<int> *ps = new PlanarSubgraphFast<int>;
    ps->runs(100);
    VariableEmbeddingInserter *ves = new VariableEmbeddingInserter;
    ves->removeReinsert(RemoveReinsertType::All);
 
    crossMin->setSubgraph(ps);
    crossMin->setInserter(ves);
    pl.setCrossMin(crossMin);
 
    EmbedderMinDepthMaxFaceLayers *emb = new EmbedderMinDepthMaxFaceLayers;
    pl.setEmbedder(emb);
 
    OrthoLayout *ol = new OrthoLayout;
    ol->separation(20.0);
    ol->cOverhang(0.4);
    pl.setPlanarLayouter(ol);
#endif

    pl.call(GA);
 


/*
	// UPWARD PLANAR REPRESENTATION
   makeSimpleUndirected(G);
   adjEntry externalFaceAdj;
   bool isUpwardPlanar = UpwardPlanarity::embedUpwardPlanar(G, externalFaceAdj);
   OGDF_ASSERT(isUpwardPlanar);

   CombinatorialEmbedding emb(G);
   emb.setExternalFace(emb.rightFace(externalFaceAdj));
   UpwardPlanRep upr(emb);
   upr.augment();

   LayerBasedUPRLayout layout;
//   GraphAttributes GA(G, GraphAttributes::nodeGraphics |
//GraphAttributes::edgeGraphics | GraphAttributes::edgeArrow);
   layout.call(upr, GA);

   // show edge arrows
   for(edge e : G.edges) {
      GA.arrowType(e) = EdgeArrow::First;
   }
*/



//   GraphIO::drawSVG(GA, "exampleGraph.svg");
//    GraphIO::write(GA, "output-ERDiagram.dot", GraphIO::writeDOT);
//    GraphIO::write(GA, "output-ERDiagram.gml", GraphIO::writeGML);
	string filename = "ogdf-test-"+util::itos(diagramnum);
	
    GraphIO::write(GA, filename+".svg", GraphIO::drawSVG);
    GraphIO::write(GA, filename+".dot", GraphIO::writeDOT);
 

/*
		cout << "Graph G planar? " << boolalpha <<  ogdf::isPlanar(G) << endl;
		cout << "Graph is directed? " << GA.directed() << endl;
	
//	DfsAcyclicSubgraph DAS;
//    DAS.callAndReverse(G);
 
//    GraphIO::write(G, "output-acyclic-graph.gml", GraphIO::writeGML);
		GraphIO::write(G, "output-graph.dot", GraphIO::writeDOT);

//		GraphIO::write(GA, "output-graph.dot", GraphIO::writeDOT);
//		GraphIO::writeDOT(GA, cout);
*/
	}
	else
		cout << "error reading graph" << endl;
 
 	
//	exit(0);
}

